import Controller from '@ember/controller';

export default class RoomsNewController extends Controller {
    @tracked newName = '';
    @tracked newAddress = '';
    @tracked newCapacity;
    @tracked newFeatures = '';
    @tracked errorName = '';
    @tracked errorAddress = '';
    @tracked errorCapacity = '';
    @tracked errorFeatures = '';

    @action
    createRoom(event) {
        event.preventDefault();
        let newRoom = this.store.createRecord('room', {
            name: this.newName,
            address: this.newAddress,
            capacity: this.newCapacity,
            features: this.newFeatures
        })
        this.errorName = '';
        this.errorAddress = '';
        this.errorCapacity = '';
        this.errorFeatures = '';
        newRoom.save().then((room) => {
            this.transitionToRoute('rooms.view', room.id)
        }).catch((response) => {
            response.errors.forEach((error) => {
                if(error.source.pointer == '/data/attributes/name') {
                    this.errorCode = error.detail;
                } else if(error.source.pointer == '/data/attributes/address') {
                    this.errorName = error.detail;
                } else if(error.source.pointer == '/data/attributes/capacity') {
                    this.errorSemester = error.detail;
                } else if(error.source.pointer == '/data/attributes/features') {
                    this.errorSemester = error.detail;
                }
            })
        })
    }
}
